
(*
 *	Copyright (c) 2002 by Laboratoire Spcification et Vrification (LSV),
 *	CNRS UMR 8643 & ENS Cachan.
 *	Written by Jean Goubault-Larrecq.  Not derived from licensed software.
 *
 *	Permission is granted to anyone to use this software for any
 *	purpose on any computer system, and to redistribute it freely,
 *	subject to the following restrictions:
 *
 *	1. Neither the author nor its employer is responsible for the consequences of use of
 *		this software, no matter how awful, even if they arise
 *		from defects in it.
 *
 *	2. The origin of this software must not be misrepresented, either
 *		by explicit claim or by omission.
 *
 *	3. Altered versions must be plainly marked as such, and must not
 *		be misrepresented as being the original software.
 *
 *	4. This software is restricted to non-commercial use only.  Commercial
 *		use is subject to a specific license, obtainable from LSV.
 *)

type 'a map

val map_read : 'a map -> int -> 'a option

exception MapRead of int
val map_read_sure : 'a map -> int -> 'a

val map_empty : 'a map -> bool
val map_singleton : int -> 'a -> 'a map
val map_add : 'a map -> int -> 'a -> 'a map
val map_add_behind : 'a map -> int -> 'a -> 'a map
val map_merge : 'a map -> 'a map -> 'a map
val map_remove : 'a map -> int -> 'a map
val map_drt : 'a map -> 'b map -> 'a map
val map_drb : 'a map -> 'b map -> 'a map
val map_subset : 'a map -> 'b map -> bool
val map_sweep : 'a map -> (int -> 'a -> bool) -> bool
val map_card : 'a map -> int
val map_choose : 'a map -> (int * 'a) option
