
(*
 *	Copyright (c) 2002 by Laboratoire Spcification et Vrification (LSV),
 *	CNRS UMR 8643 & ENS Cachan.
 *	Written by Jean Goubault-Larrecq.  Not derived from licensed software.
 *
 *	Permission is granted to anyone to use this software for any
 *	purpose on any computer system, and to redistribute it freely,
 *	subject to the following restrictions:
 *
 *	1. Neither the author nor its employer is responsible for the consequences of use of
 *		this software, no matter how awful, even if they arise
 *		from defects in it.
 *
 *	2. The origin of this software must not be misrepresented, either
 *		by explicit claim or by omission.
 *
 *	3. Altered versions must be plainly marked as such, and must not
 *		be misrepresented as being the original software.
 *
 *	4. This software is restricted to non-commercial use only.  Commercial
 *		use is subject to a specific license, obtainable from LSV.
 *)

open Intervalle

(* suite d'itv_int.mli, cf. ce fichier pour les notions de base. *)

val itv_int_bnot : Arith.int_type -> itv -> itv
	(* La negation bit a bit: l'operateur ~ de C,
	parametre par l'int_type sur lequel il agit. *)
val itv_int_left :
  Arith.int_type -> itv -> itv -> itv
	(* itv_int_left it m n effectue m<<n dans l'int_type
	considere. *)
val itv_int_right :
  Arith.int_type -> itv -> itv -> itv
	(* itv_int_right it m n effectue m<<n dans l'int_type
	considere. *)
val itv_int_and :
  Arith.int_type -> itv -> itv -> itv
	(* le et bit a bit, dans l'int_type considere. *)
val itv_int_xor :
  Arith.int_type -> itv -> itv -> itv
	(* le ou exclusif bit a bit, dans l'int_type considere. *)
val itv_int_or :
  Arith.int_type -> itv -> itv -> itv
	(* le ou bit a bit, dans l'int_type considere. *)
