
(*
 *	Copyright (c) 2002 by Laboratoire Spcification et Vrification (LSV),
 *	CNRS UMR 8643 & ENS Cachan.
 *	Written by Jean Goubault-Larrecq.  Not derived from licensed software.
 *
 *	Permission is granted to anyone to use this software for any
 *	purpose on any computer system, and to redistribute it freely,
 *	subject to the following restrictions:
 *
 *	1. Neither the author nor its employer is responsible for the consequences of use of
 *		this software, no matter how awful, even if they arise
 *		from defects in it.
 *
 *	2. The origin of this software must not be misrepresented, either
 *		by explicit claim or by omission.
 *
 *	3. Altered versions must be plainly marked as such, and must not
 *		be misrepresented as being the original software.
 *
 *	4. This software is restricted to non-commercial use only.  Commercial
 *		use is subject to a specific license, obtainable from LSV.
 *)

open Const

type sig_set = int list (* listes triees de signaux en ordre croissant *)

let sigs_empty = []

let sigs_singleton s = [s]

let rec sigs_union sigs1 sigs2 =
    match sigs1 with
	[] -> sigs2
      | s1::sigs'1 ->
	match sigs2 with
	    [] -> sigs1
	  | s2::sigs'2 ->
	    if s1<s2
		then s1::sigs_union sigs'1 sigs2
	    else if s1>s2
		then s2::sigs_union sigs1 sigs'2
	    else s1::sigs_union sigs'1 sigs'2

let all_sigs =
    let rec sigs n acc =
	if n>0 then sigs (n-1) (n::acc) else acc
    in sigs (nsignals-1) []
